function Jk = computeJoint(Marginals, Graphs, laplace_const, a_n, method, fullscore)

nmarginals = length(Marginals);
if(strcmp(method,'full'))
    M = cell(1,1);
    M{1} = 1:nmarginals;
elseif(strcmp(method,'independent'))
    M = num2cell(1:nmarginals);
elseif(strcmp(method,'partition'))
    M = getComponents(Marginals, true);
else
    error(['Unknown method' method]);
end

% For each marginal-set compute joint
Jk = cell(length(M),1);
for i = 1:length(M)
    [ Jk{i}.joint, Jk{i}.marginals, Jk{i}.prior, Jk{i}.map, Jk{i}.dims, Jk{i}.coherent ] = findJoint_KL(Marginals(M{i}), Graphs, laplace_const);

    Jk{i}.marginal_idx = M{i};
    Jk{i}.ndags = a_n * Jk{i}.prior;
    Jk{i}.st = zeros(length(M{i}),2);
    for j = 1:length(M{i})
        Jk{i}.st(j,1) = Marginals{M{i}(j)}.s;
        Jk{i}.st(j,2) = Marginals{M{i}(j)}.t;
    end
    
    if(fullscore)
        Jk{i}.score = log(Jk{i}.joint) - log(Jk{i}.prior);
    else
        Jk{i}.score = log(Jk{i}.joint);
    end
end

end
