function bool = confIsValid(st, nnodes, p)
% First create graph (+size(st,1) for the common parent node)
G = zeros(nnodes+size(st,1),nnodes+size(st,1));

for i = 1:size(st,1)
    switch p(i)
        case 1
            G(st(i,1),st(i,2)) = 1;
        case 2
            G(st(i,2),st(i,1)) = 1;
        case 3
            G(nnodes+i,st(i,1)) = 1;
            G(nnodes+i,st(i,2)) = 1;
    end
end

% Compute closure
closure = transitiveClosureSparse_mex(sparse(G));

% Check acyclicity
if(any(diag(closure)))
    bool = false;
    return;
end

% Transitive relations
for i = 1:size(st,1)
    if(closure(st(i,1),st(i,2)) && p(i) ~= 1)
        bool = false;
        return;
    elseif(closure(st(i,2),st(i,1)) && p(i) ~= 2)
        bool = false;
        return;
    end
end

% Check for presence of common ancestors
for i = 1:size(st,1)
    if(p(i) == 4)
        if(any(closure(:,st(i,1)) & closure(:,st(i,2))))
            bool = false;
            return;
        end
    end
end

bool = true;
end
