#include "mex.h"

#if MX_API_VER < 0x07030000
typedef int mwIndex;
typedef int mwSize;
#endif /* MX_API_VER */

#include <math.h>
#include <stdlib.h>
#include <string.h>

void innerFunction(const double *dims, const double *idx, mwSize ndims, mwSize nidx, double *result);

void mexFunction(int nlhs, mxArray *plhs[],
        int nrhs, const mxArray *prhs[])
{
    mwSize ndims, nidx;
    
    /* output data */
    double *result;
    
    /* arguments */
    const mxArray* dims;
    const mxArray* idx;
    
    if (nrhs != 2) {
        mexErrMsgTxt("2 inputs required.");
    }
    
    dims = prhs[0];
    idx = prhs[1];
    ndims = max(mxGetN(dims), mxGetM(dims));
    nidx = mxGetM(idx);
        
    plhs[0] = mxCreateDoubleMatrix(nidx,1,mxREAL);
    result = mxGetPr(plhs[0]);
    
    innerFunction(mxGetPr(dims), mxGetPr(idx), ndims, nidx, result);
}

void innerFunction(const double *dims, const double *idx, mwSize ndims, mwSize nidx, double *result) {
    unsigned int i,j;
    unsigned int mul;
    unsigned int res;
    
    for(j = 0; j < nidx; ++j) {
        mul = 1;
        res = 1;
        for(i = 0; i < ndims; ++i) {
            res += (*(idx + i*nidx + j) - 1) * mul;
            mul *= dims[i];
        }
        result[j] = (double) res;
    }
}
