function [prior] = computePrior(Marginals, Graphs, valid, nevents, laplace_const)

ngraphs = length(Graphs);
npk = length(Marginals);
st = zeros(npk,2);
for idx = 1:npk
    st(idx,1) = Marginals{idx}.s;
    st(idx,2) = Marginals{idx}.t;
end

dims_pow = nevents.^(0:npk-1)';

idx = ones(ngraphs,1);

for ctr = 1:ngraphs
    % Inlining for better performance
    closure = Graphs{ctr};
    for i = 1:npk
        if(closure(st(i,1),st(i,2)))
            % Do nothing
        elseif(closure(st(i,2),st(i,1)))
            idx(ctr) = idx(ctr) + dims_pow(i);
        elseif(any(closure(:,st(i,1)) & closure(:,st(i,2))))
            idx(ctr) = idx(ctr) + 2*dims_pow(i);
        else
            idx(ctr) = idx(ctr) + 3*dims_pow(i);
        end
    end
end

prior = histc(idx, valid);
prior = (prior + laplace_const)/(ngraphs + length(prior)*laplace_const);

% for i = 1:npk
%     s = Marginals{i}.s;
%     t = Marginals{i}.t;
%     
%     for ctr = 1:length(Graphs)
%         closure = Graphs{ctr};
%         if(closure(s,t))
%             % Do nothing
%         elseif(closure(t,s))
%             idx(ctr) = idx(ctr) + dims_pow(i);
%         elseif(any(closure(:,s) & closure(:,t)))
%             idx(ctr) = idx(ctr) + 2*dims_pow(i);
%         else
%             idx(ctr) = idx(ctr) + 3*dims_pow(i);
%         end
%     end
% end

end
