function [Graphs] = sampleDagsBounded(nsamples, nnodes, k)
% Samples 'nsamples' DAGs with 'nnodes' nodes in-degree at most 'k'

    function G = sampleDag
        G = zeros(nnodes,nnodes);
        order = randperm(nnodes);
        nparents = min(randi(k+1,1,nnodes)-1,0:nnodes-1);
        
        for cur = 1:nnodes-1
            G(randperm(cur-1,nparents(cur)),cur) = 1;
        end
        G = G(order,order);
    end

Graphs = cell(nsamples,1);
for ctr = 1:nsamples
    Graphs{ctr} = double(sampleDag());
end

end
