function [score,prior,likelihood] = bdeu(D, numLevels, i, pa_i, N_prime)
%BDEU Summary of this function goes here
%   Detailed explanation goes here

% References:
% [1] David Heckerman, Dan Geiger, and David M. Chickering. Learning
%     bayesian networks: The combination of knowledge and statistical data.
%     In KDD Workshop, pages 85-96, 1

% param: N
% The output prior is not used, but set to 0

numParentLevels = prod(numLevels(pa_i));

N_prime_ijk = N_prime/(numParentLevels*numLevels(i));
N_prime_ij = N_prime/numParentLevels;

N_ijk_s = reshape(count((D(:,[pa_i i])) * [1 cumprod(numLevels(pa_i))]' + 1, numParentLevels * numLevels(i)), numParentLevels, numLevels(i)) + N_prime_ijk;
N_ij_s = sum(N_ijk_s, 2);

% compute log prior [1] / # nodes
% delta = length(pa_i); % because the prior network is the empty network
% kappa = 1/(N_prime + 1);
% prior = delta*log(kappa);
prior = 0;

% likelihood2 = numParentLevels * gammaln(N_prime_ij);
% for qi = 1:numParentLevels
%     likelihood2 = likelihood2 - gammaln(N_ij_s(qi));
%     for ri = 1:numLevels(i)
%         likelihood2 = likelihood2 - gammaln(N_prime_ijk) + gammaln(N_ijk_s(qi,ri));
%     end
% end

likelihood = numParentLevels * gammaln(N_prime_ij) - sum(gammaln(N_ij_s)) + ...
    sum(sum(gammaln(N_ijk_s))) - numParentLevels*numLevels(i)*gammaln(N_prime_ijk);

% add them
score = prior + likelihood;

end
