function [G dnc] = PC_rules(G, sepSets, screen)

unshieldedtriples = getUnshieldedTriples(G);
[G, dnc] = R0(G, unshieldedtriples, sepSets, screen);

flag=1;
while(flag)
    flag=0;
    [G,flag] = R1(G, flag, screen);
    [G,flag] = R2(G, flag, screen);
    [G,flag] = R3(G, flag, screen);
end

end

function [Pdag, dnc] = R0(Pdag, unshieldedtriples, sepSets, screen)
% If a b not adjacent, c not in sepSet(a,b) => a->c<-b
nnodes = length(Pdag);
dnc = cell(nnodes,1);

for c = 1:nnodes
    curtriples = unshieldedtriples{c};
    ntriples = size(curtriples,1);
    
    if(ntriples > 0)
        sep = false(ntriples,1);
        for i = 1:ntriples
            sep(i) = sepSets(curtriples(i,1),curtriples(i,2),c);
        end
        dnc{c} = curtriples(sep,:);
        Pdag(curtriples(~sep,1),c) = 2;
        Pdag(c,curtriples(~sep,1)) = 3;
        Pdag(curtriples(~sep,2),c) = 2;
        Pdag(c,curtriples(~sep,2)) = 3;
        
        if(screen)
            idx = find(~sep)';
            for i = idx
                fprintf('R0: Orienting %d->%d<-%d\n',curtriples(i,1),c,curtriples(i,2));
            end
        end
    else
        dnc{c} = zeros(0,2);
    end
end

end

function [G flag] = R1(G, flag, screen)
% If a->bo-oc and a,c not adjacent ==> a->b->c
[b c] = find(G == 1);
len = length(b);

for i = 1:len
    if(G(b(i),c(i)) == 1 && any(G(:,b(i)) == 2 & G(:,c(i)) == 0))
        if(screen)
            fprintf('R1: Orienting %d->%d\n',b(i),c(i));
        end
        G(b(i),c(i)) = 2;
        G(c(i),b(i)) = 3;
        flag = 1;
    end
end

end

function [G flag] = R2(G, flag, screen)
% If a->b->c and ao-oc == > a->c
[a c] = find(G == 1);
len = length(a);
for i = 1:len
    if(G(a(i),c(i)) == 1 && any(G(a(i),:) == 2 & G(:,c(i))' == 2))
        if(screen)
            fprintf('R2: Orienting %d->%d\n',a(i),c(i));
        end
        G(a(i),c(i)) = 2;
        G(c(i),a(i)) = 3;
        flag = 1;
    end
end

end

function [G flag] = R3(G, flag, screen)
% If x->z, y->z, xo-owo-oy, zo-ow, x,y not adjacent ==> w->z
[w z] = find(G == 1);
len = length(w);

for i = 1:len
    if(G(w(i),z(i)) == 1)
        x = find(G(:,z(i)) == 2 & G(:,w(i)) == 1);
        lenx = length(x);
        f = false;
        for j = 1:lenx
            for k = j+1:lenx
                if(G(x(j),x(k)) == 0)
                    if(screen)
                        fprintf('R3: Orienting %d->%d\n',w(i),z(i));
                    end
                    G(w(i),z(i)) = 2;
                    G(z(i),w(i)) = 3;
                    flag = 1;
                    f = true;
                    break;
                end
            end
            if(f)
                break;
            end
        end
    end
end

end
