function G = PC_rules_apply(G, screen)
% Meek's Algorithm
% - Can be optimized

flag=1;
while(flag)
    flag=0;
    [G,flag] = R1(G, flag, screen);
    [G,flag] = R2(G, flag, screen);
    [G,flag] = R3(G, flag, screen);
    [G,flag] = R4(G, flag, screen);
end

end

function [G flag] = R1(G, flag, screen)
% If a->bo-oc and a,c not adjacent ==> a->b->c
[b c] = find(G == 1);
len = length(b);

for i = 1:len
    if(G(b(i),c(i)) == 1 && any(G(:,b(i)) == 2 & G(:,c(i)) == 0))
        if(screen)
            fprintf('R1: Orienting %d->%d\n',b(i),c(i));
        end
        G(b(i),c(i)) = 2;
        G(c(i),b(i)) = 3;
        flag = 1;
    end
end

end

function [G flag] = R2(G, flag, screen)
% If a->b->c and ao-oc == > a->c
[a c] = find(G == 1);
len = length(a);
for i = 1:len
    if(G(a(i),c(i)) == 1 && any(G(a(i),:) == 2 & G(:,c(i))' == 2))
        if(screen)
            fprintf('R2: Orienting %d->%d\n',a(i),c(i));
        end
        G(a(i),c(i)) = 2;
        G(c(i),a(i)) = 3;
        flag = 1;
    end
end

end

function [G flag] = R3(G, flag, screen)
% If x->z, y->z, xo-owo-oy, zo-ow, x,y not adjacent ==> w->z
[w z] = find(G == 1);
len = length(w);

for i = 1:len
    if(G(w(i),z(i)) == 1)
        x = find(G(:,z(i)) == 2 & G(:,w(i)) == 1);
        lenx = length(x);
        f = false;
        for j = 1:lenx
            for k = j+1:lenx
                if(G(x(j),x(k)) == 0)
                    if(screen)
                        fprintf('R3: Orienting %d->%d\n',w(i),z(i));
                    end
                    G(w(i),z(i)) = 2;
                    G(z(i),w(i)) = 3;
                    flag = 1;
                    f = true;
                    break;
                end
            end
            if(f)
                break;
            end
        end
    end
end

end

function [G flag] = R4(G, flag, screen)
% If x->z->y, xo-owo-oy, x,y not adjacent ==> w->y
[x w] = find(G == 1);
len = length(x);
nnodes = length(G);

for i = 1:len
    if(G(x(i),w(i)) == 1)
        for y = 1:nnodes
            if(G(y,w(i)) == 1 && G(x(i),y) == 0)
                if(any(G(x(i),:) == 2 & G(y,:) == 3))
                    G(w(i),y) = 2;
                    G(y,w(i)) = 3;
                    flag = 1;
                    if(screen)
                        fprintf('R4: Orienting %d->%d\n',w,y);
                    end
                end
            end
        end
    end
end

end
