function [unshieldedtriples] = getUnshieldedTriples(G)
% Returns all unshielded triples in G
% G can be of any form (0/1 or 0/1/2/3)

nnodes = length(G);
unshieldedtriples = cell(nnodes,1);

for i = 1:nnodes
    neighbours = find(G(i,:)');
    [x y] = find(triu(~G(neighbours,neighbours)) & ~eye(length(neighbours)));
    unshieldedtriples{i} = [neighbours(x) neighbours(y)];
end

end
