function PK = createPK_weighted(graph, pair, singleprior, p)

closure = transitiveClosure_mex(graph);

v1 = pair(1);
v2 = pair(2);

PK.s = v1;
PK.t = v2;


if(closure(v1,v2)) 
    % Case v1-->v2
    s = sum(singleprior([2 3 4]));
    PK.w = [p (1-p)*singleprior(2)/s (1-p)*singleprior(3)/s (1-p)*singleprior(4)/s];
elseif(closure(v2,v1)) 
    % Case v1<--v2
    s = sum(singleprior([1 3 4]));
    PK.w = [(1-p)*singleprior(1)/s p (1-p)*singleprior(3)/s (1-p)*singleprior(4)/s];
elseif(any(closure(:,v1) & closure(:,v2))) 
    % Case v1<-->v2
    s = sum(singleprior([1 2 4]));
    PK.w = [(1-p)*singleprior(1)/s (1-p)*singleprior(2)/s p (1-p)*singleprior(4)/s];
else
    % Case v1-/-v2
    s = sum(singleprior([1 2 3]));
    PK.w = [(1-p)*singleprior(1)/s (1-p)*singleprior(2)/s (1-p)*singleprior(3)/s p];
end

end
